#include "hmg.ch"

#define TEST_WITH_BROWSE .t.


 Function Main

	Local aValue := { 0 , 0 }

	local aStructureOfHeaders, aStructureOfPositions
	
	SET EXCLUSIVE ON
	//REQUEST("DBFCDX")
	
	// first, we need to create database for test
	// we will have 1 to n relation from headers to positions
	
	if file("headers.dbf")
		delete file headers.dbf
	endif
	
	if file("positions.dbf")
		delete file positions.dbf
	endif
	
	aStructureOfInvoices := {	{ "ID","C",6,0},;
								{ "FullNumber","C",11,0} }

	aStructureOfPositions	:= {	{ "ID","C",6,0},;
									{ "Lp","N",2,0 } ,;
									{ "TimeStamp","C",20,0},;
									{ "AnyText","C",40,0 } }

	DBCreate("invoices",aStructureOfInvoices)
	DBCreate("positions",aStructureOfPositions)

	use invoices new
	
	index on ID to invoices1
	set index to invoices1
	
	use positions new
	
	index on ID to positions1
	set index to positions1
	
	// fill dbf files
	
	for i := 1 to 20
		invoices->(AddRec())
		replace;
			invoices->ID	with str(i,6,0) ,;
			invoices->FullNumber with str(i,6,0)+"/"+str(year(date()),4,0)
		
		for j := 1 to 2+i*2
			positions->(AddRec())
			replace;
				positions->ID	with invoices->ID ,;
				positions->LP	with j ,;
				positions->TimeStamp	with time() ,;
				positions->AnyText	with "This is pos.no "+alltrim(str(j,0))+" of header record #"+alltrim(str(i,0))
		next j
	next i
	
	invoices->(DBGoTop())
	positions->(OrdScope(0,invoices->ID))
	positions->(OrdScope(1,invoices->ID))
	positions->(DBGoTop())	
									
	* Headers Grid Column Controls Definitions
	aInvoicesControls := {	{'TEXTBOX','CHARACTER'} ,;
							{'TEXTBOX','CHARACTER'} }

	aPositionsControls := {	{'TEXTBOX','CHARACTER'} ,;
							{'TEXTBOX','NUMERIC'} ,;
							{'TEXTBOX','CHARACTER'} ,;
							{'TEXTBOX','CHARACTER'} }
	aInvoicesHeaders	:= { "ID","Number"}
	aInvoicesWidths	:= { 60,120}
	aInvoicesJust	:= { 0,1}
	aInvoicesFields	:= {"ID","FullNumber"}
	
	aPositionsHeaders	:=	{ "ID","Lp","TimeStamp","Any text" }
	aPositionsWidths	:=	{ 60,60,100,300 }
	aPositionsJust		:=	{ 0,1,0,0 }
	aPositionsFields	:=	{ "ID","LP","TimeStamp","AnyText" }
	
	DEFINE WINDOW Form_1 ;
		AT 0,0 ;
		WIDTH 900 ;
		HEIGHT 610 ;
		TITLE 'GRID and OrdScope test' ;
		MAIN 

		@ 10,10 LABEL L1 ;
			VALUE "Invoices"
		#ifdef TEST_WITH_BROWSE	
			@ 40,10 BROWSE Grid_Invoices ;
				WIDTH 210 ;
				HEIGHT 500 ;
				HEADERS aInvoicesHeaders ;
				WIDTHS aInvoicesWidths ;
				WORKAREA invoices ;
				FIELDS aInvoicesFields ;
				ON CHANGE UpdatePositions()
		#else
			@ 40,10 GRID Grid_Invoices ;
				WIDTH 210 ;
				HEIGHT 500 ;
				HEADERS aInvoicesHeaders ;
				WIDTHS aInvoicesWidths ;
				ROWSOURCE "invoices" ;
				COLUMNFIELDS aInvoicesFields ;
				COLUMNCONTROLS aInvoicesControls ;
				ON CHANGE UpdatePositions()
		#endif
			
		@ 10,240 LABEL L2 ;
			VALUE "Positions"

		#ifdef TEST_WITH_BROWSE
		@ 40,240 BROWSE Grid_Positions ;
			WIDTH 640 ;
			HEIGHT 500 ;
			HEADERS aPositionsHeaders ;
			WIDTHS aPositionsWidths ;
			WORKAREA positions ;
			FIELDS aPositionsFields 
		#else
		@ 40,240 GRID Grid_Positions ;
			WIDTH 640 ;
			HEIGHT 500 ;
			HEADERS aPositionsHeaders ;
			WIDTHS aPositionsWidths ;
			ROWSOURCE "positions" ;
			COLUMNFIELDS aPositionsFields ;
			COLUMNCONTROLS aPositionsControls
		#endif
		
	END WINDOW

	CENTER WINDOW Form_1
	
	#ifdef TEST_WITH_BROWSE
		Form_1.Grid_Invoices.Value := invoices->(RecNo())
	#else
		Form_1.Grid_Invoices.RecNo := invoices->(RecNo())
	#endif
	
	ACTIVATE WINDOW Form_1

 Return
*******************************************************************************
Procedure AddRec
	append blank
 return 
*******************************************************************************
Procedure UpdatePositions()


	// clear previous ordscopes
	positions->(OrdScope(0,NIL))
	positions->(OrdScope(1,NIL))
	positions->(DBGoTop())
	
	#ifdef TEST_WITH_BROWSE
		invoices->(DBGoTo(Form_1.Grid_Invoices.Value))
	#endif
	
	positions->(OrdScope(0,invoices->ID))
	positions->(OrdScope(1,invoices->ID))
	positions->(DBGoTop())

	
	
	MsgInfo("Positions will be set to ID #" + invoices->ID)
	
	#ifdef TEST_WITH_BROWSE
		Form_1.Grid_Positions.Value := positions->(recno())
	#else
		Form_1.Grid_Positions.RecNo := positions->(recno())
		Form_1.Grid_Positions.Refresh
	endif
	
 return